/*
 * CheckableListItem.cpp
 *
 *  Created on: 8.1.2010
 *      Author: apoi
 */

#ifndef CHECKABLELISTITEM_H
#define CHECKABLELISTITEM_H

#include <QFrame>

class MDragWidget;
class QImage;

namespace Ui {
    class CheckableListItem;
}

class CheckableListItem : public QFrame
{
    Q_OBJECT

public:
    enum TItemType
    {
    	ECategory,
    	EImage
    };
    
public:
    CheckableListItem(CheckableListItem::TItemType aItemType, const QString& aItemId, bool aChecked, MDragWidget& aParent);
    ~CheckableListItem();
    bool IsChecked() const;
    void SetCheckState(bool aState);
    const QString& ItemId() const;
    void InitImageItem(const QString& aFilename, const QString& aDate, const QString& aSize);
    void InitCategoryItem(const QString& aCategoryName, int aCategoryLevel);
    bool ThumbnailCreated() const;
    void CreateThumbnail(const QImage& aImage);
    void ThumbnailCreationStarted();

protected:
    void changeEvent(QEvent *e);
    void mouseReleaseEvent(QMouseEvent *e);
    void keyReleaseEvent(QKeyEvent *e);

private slots:
    void CreateThumbnail();
    
private:
    void UpdateCheckState();
    
private:
    Ui::CheckableListItem *ui;

    const TItemType iItemType;
    const QString iItemId;
    bool iChecked;
    const MDragWidget& iParent;

    bool iThumbnailCreated;
};

#endif // CHECKABLELISTITEM_H
