/*
 * ErrorDialog.h
 *
 *  Created on: 5.1.2010
 *      Author: apoi
 */

#include <QSize>
#include <QDesktopWidget>

#include "DialogController.h"
#include "ErrorDialog.h"

ErrorDialog::ErrorDialog(QWidget *parent) : QDialog(parent)
{
    ui.setupUi(this);
    
    // signal from button
    connect(ui.pushButton, SIGNAL(clicked()), this, SLOT(accept()));

// maemo uses click-on-background to dismiss    
#ifdef Q_WS_MAEMO_5
    // modal dialog at bottom of screen
    setWindowFlags(Qt::Dialog);

    // use window's own title
    ui.titleLabel->hide();

    // use background to dismiss
//    ui.pushButton->hide();

#else // XXX: symbian
    // popup in center of screen
    setWindowFlags(Qt::Popup);

#endif
}

ErrorDialog::~ErrorDialog()
{

}
    
void ErrorDialog::ShowError (const QString &title, const QString &error)
{
#ifdef Q_WS_MAEMO_5
    // use dialog frame title
    setWindowTitle(title);
#else        
    ui.titleLabel->setText(title);
#endif

    ui.errorNote->setText(error);
    
    open();

#ifdef Q_WS_SYMBIAN
    // XXX: center popup, does this happen by default?
    QSize parentSize = QApplication::desktop()->screenGeometry().size();
    move((parentSize.width() - width()) / 2, (parentSize.height() - height()) / 2);
#endif
}

