
#include <QDir>
#include <QFileInfo>
#include "ImageSearchThread.h"

ImageSearchThread::ImageSearchThread(QObject* parent)
    : QThread(parent), iThreadCancelled(false)
{
}

ImageSearchThread::~ImageSearchThread()
{

}

void ImageSearchThread::run()
{
#ifdef Q_OS_SYMBIAN
    QDir phoneMemory("C:\\Data\\Images");
    if (!iThreadCancelled)
        ParseDir(phoneMemory);
    QDir memoryCard("E:\\Images");
    if (!iThreadCancelled)
        ParseDir(memoryCard);
#else
    QDir dcim("/home/user/MyDocs/DCIM");
    if (!iThreadCancelled)
        ParseDir(dcim);
    QDir images("/home/user/MyDocs/.images");
    if (!iThreadCancelled)
        ParseDir(images);
    QDir camera("/home/user/MyDocs/.camera");
    if (!iThreadCancelled)
        ParseDir(camera);
    QDir mmcImages("/media/mmc1/");
    if (!iThreadCancelled)
        ParseDir(mmcImages);
#endif
}

void ImageSearchThread::ParseDir(const QDir& aDir)
{
    QStringList filters;
    filters << "*.jpg" << "*.jpeg";
    QFileInfoList contents(aDir.entryInfoList(filters, QDir::NoDotAndDotDot | QDir::AllDirs | QDir::Files));

    const int count = contents.size();
    for (int i = 0; i < count; i++)
    {
        if (iThreadCancelled)
            return;
        if (contents[i].isDir())
            ParseDir(contents[i].filePath());
        else
            emit ImageFound(contents[i]);
    }
}

void ImageSearchThread::Cancel()
{
    iThreadCancelled = true;
}
