#ifndef IMAGETHUMBNAILTHREAD_H
#define IMAGETHUMBNAILTHREAD_H

#include <QMutex>
#include <QPair>
#include <QStringList>
#include <QSize>
#include <QThread>

class QImage;

class ImageThumbnailThread : public QThread
{
    Q_OBJECT

public:
    ImageThumbnailThread(const QSize& aSize, QObject* parent = 0);
    ~ImageThumbnailThread();

public:
    void run();
    void Cancel();

public slots:
    void AddImage(QString aFilename, int aIndex);

signals:
    void ThumbnailCreated(int aIndex, const QImage& aImage);

private:
    const QSize iSize;
    QList<QPair<QString, int> > iImageList;
    volatile bool iThreadCancelled;
    
    QMutex iMutex;
};

#endif // IMAGESEARCHTHREAD_H
