/*
 * SinglePostData.cpp
 *
 *  Created on: 16.12.2009
 *      Author: apoi
 */

#include <QDesktopWidget>

#include "SinglePostData.h"
#include "WPNetworkEngine.h"

SinglePostData::SinglePostData(QWidget* aParent, WPPost aPost) : QFrame(aParent)
{
    SetScreenMaxSize();

    ui.setupUi(this);
    ui.title->setText(aPost->iTitle);
    ui.tags->setText(tr("Tags: ") + aPost->iMtKeywords);

    QString categoryText = tr("Categories: ");
    const int categoryCount = aPost->iCategories.size();
    for (int i = 0; i < categoryCount; ++i)
    {
        categoryText += aPost->iCategories[i];
        categoryText += ", ";
    }
    if (categoryCount > 0)
        categoryText = categoryText.left(categoryText.length() - 2);
    ui.categories->setText(categoryText);
    ui.content->setText(aPost->GetDisplayHTML());
    ui.content->setTextFormat(Qt::RichText);
    ui.date->setText(aPost->iWpAuthorDisplayName + ' ' + aPost->GetShortLocalTimeString());
}

SinglePostData::~SinglePostData()
{

}

void SinglePostData::SetScreenMaxSize()
{
    setMaximumWidth(QApplication::desktop()->screenGeometry().size().width());
}

void SinglePostData::resizeEvent(QResizeEvent *e)
{
    SetScreenMaxSize();
    QWidget::resizeEvent(e);
}
