#ifndef BUTTONGRAPHICSPROXY_H_
#define BUTTONGRAPHICSPROXY_H_

#include <QGraphicsProxyWidget>
#include <QPushButton>

// QGRaphicsProxyWidget doesn't work properly on symbian...
class ButtonGraphicsProxy : public QGraphicsProxyWidget
{
    Q_OBJECT
    
public:
    ButtonGraphicsProxy(QString const & buttonName, QGraphicsItem * parent)
      : QGraphicsProxyWidget(parent)
        {
        button_ = new QPushButton(buttonName);
        setWidget(button_);
        }
    
    QPushButton * button() { return button_; }
    
    bool event(QEvent * event)
        {
        if(event->type() == QEvent::KeyPress)
            {
            QKeyEvent *k = static_cast<QKeyEvent *>(event);
            if(k->key() == Qt::Key_Select)
                {
                button()->click();
                event->accept();
                return true;
                }
            }
        return QGraphicsProxyWidget::event(event);
        }
    
private:
    QPushButton * button_;
};

#endif /* BUTTONGRAPHICSPROXY_H_ */
