#ifndef COLLECTIONLIST_H
#define COLLECTIONLIST_H

#include <QtGui/QWidget>
#include "ui_collectionlist.h"
#include <QList>

class BlogView;
class QAction;
class TextListItem;
class WPScrollArea;
class PopupMenu;
class ThemeData;

class CollectionList : public QWidget
{
    Q_OBJECT

public:
    enum TMenuAction
    {
    	EOpen,
    	EEdit,
    	EDelete
    };
    
public:
    CollectionList(QWidget *parent, WPScrollArea& aScrollArea, ThemeData& aThemeData);
    ~CollectionList();

public:
    void SetTitle(const QString& aTitle, bool aCanHaveFocus = false);
    void AddCustomItem(const QString& aItemId, const QString& aTitle, const QString& aFrom, const QStringList& aDetails);
    void RemoveItem(QWidget* aItem);
    void ResetList();
    void SetTitle();
    void AddStretch();
    void setFocus();
    int ItemCount() const;
    void DisableMenuAction(CollectionList::TMenuAction aAction);

public slots:
    void MenuHiding();
    void ShowContextMenu(TextListItem* aItem);

protected:
    void resizeEvent(QResizeEvent* event);
    QPoint getMenuLocation(QPoint itemPoint);

private:
    QString iTitle;

public:
    WPScrollArea& iScrollArea;
    Ui::CollectionListClass ui;
    QAction* iActionOpen;
    QAction* iActionEdit;
    QAction* iActionDelete;
    TextListItem* iCurrentItem;
    int iStretchCount;
    QList<CollectionList::TMenuAction> iDisabledActions;
    PopupMenu* iPopupMenu;
};

#endif // COLLECTIONLIST_H
