/*
 * lineplot.h
 *
 *  Created on: 22.3.2010
 *      Author: aahv
 */

#ifndef LINEPLOT_H
#define LINEPLOT_H

#include "lineplotdata.h"

#include <QWidget>

class LinePlot : public QWidget
{
public:
    LinePlot(QWidget* parent=0);

    void setData(LinePlotData* data);

    void setXAxisMajorTickFrequency(int freq);

protected:
    void resizeEvent(QResizeEvent* event);
    void paintEvent(QPaintEvent* event);

    void drawAxis(QPainter& painter);
    void drawData(QPainter& painter);

    void calculateGeometry();

private:
    LinePlotData* data;

    QFont font;
    QRect yAxisLabelMetrics;
    QRect xAxisLabelMetrics;

    QPoint origo;
    QPoint xAxisEnd;
    QPoint yAxisEnd;

    int xAxisMajorTickFreq;
    int xAxisTickCount;
    int yAxisTickCount;

    bool zeroVisible;
    bool gridVisible;

};

#endif // LINEPLOT_H
