TEMPLATE = app
TARGET = WordPress
VERSION = 0.7.2
QT += core \
    gui \
    network \
    xml \
    webkit \
    svg
HEADERS += utils.h \
    addlinkdialog.h \
    enume/pannableview.h \
    enume/pannableview_p.h \
    wpcommentgraphicslist.h \
    wpcommentgraphicslistitem.h \
    wplabel.h \
    wptextbrowser.h \
    ImageThumbnailThread.h \
    richtextedit.h \
    wpscrollarea.h \
    explanatorytextedit.h \
    explanatorylineedit.h \
    CheckableListItem.h \
    clippinglabel.h \
    ErrorDialog.h \
    DialogController.h \
    ImageSearchThread.h \
    CategoryView.h \
    ProgressDialog.h \
    BlogSetupView.h \
    AddComment.h \
    SinglePostData.h \
    MDragWidget.h \
    ImageSelectionList.h \
    SinglePostView.h \
    textlistitem.h \
    PopupMenu.h \
    wpcommentlist.h \
    wpcommentlistitem.h \
    md5.h \
    WPXmlRsdParser.h \
    WPData.h \
    WPDataItem.cpp \
    BlogView.h \
    collectionlist.h \
    setupblog.h \
    addpostview.h \
    WPNetworkEngine.h \
    writepageview.h \
    WPXmlStatsParser.h \
    statisticsview.h \
    apikeydialog.h \
    statsvisits.h \
    statslistview.h \
    lineplot.h \
    statsdailydata.h \
    lineplotdata.h \
    statsmonthlydata.h \
    statsweeklydata.h \
    busyindicator.h \
    WPXmlRequest.h \
    WPXmlResponse.h \
    wptabbargraphicswidget.h \
    wppagegraphicslist.h \
    wppagegraphicslistitem.h \
    wppostgraphicslist.h \
    wppostgraphicslistitem.h \
    wpstackedgraphicswidget.h \
    themedatastorage.h \
    wpcommongeometry.h \
    wpcustomviewbasicdata.h \
    wpkeydispatcher.h \
    wpconfirmdialog.h \
    version.h \
    wpgraphicslistitem.h \
    wpgraphicslist.h \
    wpbloggraphicslist.h \
    wpbloggraphicslistitem.h \
    wpexpandingtabwidget.h \
    ScopedTimer.h \
    wptitlebar.h \
    wpmenubar.h \
    wptabbedlistview.h \
    wpgraphicsview.h \
    wpmsghandler.h \
    scopedtracer.h \
    WPDataCustomField.h \
    wpcustomgraphicsitemtypes.h \
    graphicslayoutiterator.h \
    buttongraphicsproxy.h
SOURCES += addlinkdialog.cpp \
    enume/pannableview.cpp \
    wpcommentgraphicslist.cpp \
    wpcommentgraphicslistitem.cpp \
    wplabel.cpp \
    wptextbrowser.cpp \
    ImageThumbnailThread.cpp \
    richtextedit.cpp \
    wpscrollarea.cpp \
    explanatorytextedit.cpp \
    explanatorylineedit.cpp \
    CheckableListItem.cpp \
    clippinglabel.cpp \
    ErrorDialog.cpp \
    DialogController.cpp \
    ImageSearchThread.cpp \
    CategoryView.cpp \
    ProgressDialog.cpp \
    BlogSetupView.cpp \
    AddComment.cpp \
    SinglePostData.cpp \
    SinglePostView.cpp \
    ImageSelectionList.cpp \
    textlistitem.cpp \
    PopupMenu.cpp \
    wpcommentlist.cpp \
    md5.cpp \
    wpcommentlistitem.cpp \
    WPXmlRsdParser.cpp \
    WPData.cpp \
    WPDataGravatars.cpp \
    WPDataPage.cpp \
    WPDataPost.cpp \
    WPDataComment.cpp \
    BlogView.cpp \
    collectionlist.cpp \
    setupblog.cpp \
    addpostview.cpp \
    WPNetworkEngine.cpp \
    writepageview.cpp \
    main.cpp \
    WPXmlStatsParser.cpp \
    statisticsview.cpp \
    apikeydialog.cpp \
    statsvisits.cpp \
    statslistview.cpp \
    lineplot.cpp \
    statsdailydata.cpp \
    lineplotdata.cpp \
    statsmonthlydata.cpp \
    statsweeklydata.cpp \
    busyindicator.cpp \
    WPXmlRequest.cpp \
    WPXmlResponse.cpp \
    wptabbargraphicswidget.cpp \
    wppagegraphicslist.cpp \
    wppagegraphicslistitem.cpp \
    wppostgraphicslist.cpp \
    wppostgraphicslistitem.cpp \
    wpstackedgraphicswidget.cpp \
    wpconfirmdialog.cpp \
    themedatastorage.cpp \
    wpgraphicslistitem.cpp \
    wpgraphicslist.cpp \
    wpbloggraphicslist.cpp \
    wpbloggraphicslistitem.cpp \
    wptitlebar.cpp \
    wpmenubar.cpp \
    wptabbedlistview.cpp \
    wpgraphicsview.cpp \
    wpmsghandler.cpp \
    scopedtracer.cpp \
    WPDataCustomField.cpp \
    graphicslayoutiterator.cpp
FORMS += addlinkdialog.ui \
    richtextedit.ui \
    AddComment.ui \
    wpcommentlistitem.ui \
    writepageview.ui \
    collectionlist.ui \
    setupblog.ui \
    addpostview.ui \
    SinglePostData.ui \
    ProgressDialog.ui \
    ErrorDialog.ui \
    CheckableListItem.ui \
    statisticsview.ui \
    apikeydialog.ui \
    statsvisits.ui \
    statslistview.ui \
    wpconfirmdialog.ui
RESOURCES += images.qrc \
    stylesheet.qrc

# version numbers (does not work at least on 3.2 symbian sdk)
# DEFINES += WP_VERSION=\"$$VERSION\" WP_USERAGENT=\"wp-nokia/$$VERSION\"
# profiling
gprof { 
    QMAKE_CXXFLAGS_DEBUG += -pg
    QMAKE_LFLAGS_DEBUG += -pg
}

# "real" mobile platforms
symbian|maemo5 { 
    # QtMobility::QSystemInfo
    CONFIG += mobility
    MOBILITY = systeminfo
    
    # MOBILITY += bearer
    DEFINES += HAVE_QTMOBILITY
    
    # qtAddLibrary(QtBearer)
    qtAddLibrary(QtSystemInfo)
    qtAddLibrary(QtLocation)
}
maemo5 { 
    MOBILITY += location
    DEFINES += HAVE_QTM_LOCATION
    HEADERS += LocationFinder.h
    SOURCES += LocationFinder.cpp
}
symbian: { 
    ICON = images/wp-logo.svg
    TARGET.UID3 = 0xE0007242
    TARGET.CAPABILITY = "NetworkServices ReadUserData WriteUserData"
    HEADERS += sym_iap_util.h \
        WordPress.loc
    SOURCES += WordPress_reg.rss \
        WordPress.rss
    INCLUDEPATH += middleware
    LIBS += -lesock \
        -lcommdb \
        -linsock \
        -lefsrv \
        -leikcore \
        -leikcoctl \
        -lavkon \
        -lcone # For IAP selection
    
    # Embed qt mobility
    qt_mobility_sis.pkg_postrules = "@\"../../third_party/qt-mobility-symbian-opensource-1.0.1/QtMobility_Express_Signed.sis\",(0x2002AC89)"
    DEPLOYMENT += qt_mobility_sis
}

# Linux platforms (primarily for maemo, but also general linux)
unix:!symbian { 
    # the linux-g++-maemo mkspec already does this, assuming that we use it
    # compile release builds with debug syms
    # we strip this out into *-dbg
    # QMAKE_CXXFLAGS_RELEASE += -g
    # CONFIG += nostrip
    # place output files in /bin
    DESTDIR = ../bin
    
    # compile inside /build
    OBJECTS_DIR = ../build/obj
    MOC_DIR = ../build/moc
    UI_DIR = ../build/ui
    RCC_DIR = ../build/res
    
    # default prefix
    isEmpty(PREFIX):PREFIX = /usr/local
    
    # install path
    BINDIR = $$PREFIX/bin
    DATADIR = $$PREFIX/share
    DEFINES += DATADIR=\\\"$$DATADIR\\\" \
        PKGDATADIR=\\\"$$PKGDATADIR\\\"
    
    # make install
    INSTALLS += target \
        desktop \
        iconxpm \
        icon26 \
        icon48 \
        icon64
    
    # Maemo-specifics
    maemo5 { 
        # Used for "Expose" button
        QT += dbus
        
        # Application shortcut
        desktop.path = $$DATADIR/applications/hildon
        desktop.files += $${TARGET}.desktop
    }
    target.path = $$BINDIR
    iconxpm.path = $$DATADIR/pixmaps
    iconxpm.files += images/$${TARGET}.xpm
    icon26.path = $$DATADIR/icons/hicolor/26x26/apps
    icon26.files += images/26/$${TARGET}.png
    icon48.path = $$DATADIR/icons/hicolor/48x48/apps
    icon48.files += images/48/$${TARGET}.png
    icon64.path = $$DATADIR/icons/hicolor/64x64/apps
    icon64.files += images/64/$${TARGET}.png
}
