#ifndef TEXTLISTITEM_H
#define TEXTLISTITEM_H

#include <QtGui/QFrame>



class TextListItem : public QFrame
{
    Q_OBJECT

public:
    TextListItem(const QString& aItemId, const QString& aTitle, const QString& aFrom,
                 const QStringList& aDetails, QWidget *parent = 0);
    ~TextListItem();

public:
    QPoint TopRight() const;
    const QString& ItemId() const {return iItemId;};

signals:
    void TextListItemSelected(TextListItem* aTextListItem);

private:
    void AddTitleLabel(const QString& aTitleText);
    void AddDetailLabel(const QString& aDetailText);
    void AddFromLabel(const QString& aFromText);
    void mouseReleaseEvent(QMouseEvent *e);
    void keyReleaseEvent(QKeyEvent *e);
    void keyPressEvent(QKeyEvent *e);

private:
    QString iItemId;
    bool iKeyPressReceived;

};

#endif // TEXTLISTITEM_H
