/*
 * themedatastorage.h
 *
 *  Created on: 27.5.2010
 *      Author: jlep
 */

#ifndef THEMEDATASTORAGE_H_
#define THEMEDATASTORAGE_H_

#include <QPixmap>
#include <QIcon>

class ThemeData
{
public:
    enum TIconSheet
    {
        EMainWindow = 0,
        EComments = 1,
        EHome,
        ELink,
        EImaging,
        EPages = 5,
        EPower,
        ETools,
        ESwitch,
        EPosts = 9,
        EUsers = 10,
        EKeys = 11
    };
    
    enum TContextIconSheet
    {
        EApprove = 0,
        EEdit = 1,
        EOpen,
        ERemove,
        EReply,
        ESpam = 5,
        EView = 6
    };
public:
    ThemeData();
    ~ThemeData();
    void Init();

public:
    
    // Tabbar
    QBrush*  iTabGradientBrush;
    QFont*   iTabFont;
    QPixmap* iListItemPixmap;
    int      iListItemShadowMargin;
    QList<QPixmap> iIcons;
    int      iTabBarHeight;
    QSizeF   iMinTabSize;

    // Common
    QList<QIcon> iContextMenuIcons;
    
    // List stuff
    QFont* iListTitleFont;   // Titles
    QFont* iListContentFont; // Main content
    QFont* iListInfoFont;    // Post author, post title of comments, etc.
    QFont* iListDetailFont;  // email, date etc.
    
    int    iListItemPadding;
    bool   iListShowCommentIcons;
    
    int    iListTitleHeight;
    int    iListItemSpacing;
};


#endif //THEMEDATASTORAGE_H_
