#ifndef UTILS_H_
#define UTILS_H_

#include <QApplication>
#include <QDesktopWidget>
#include <QGraphicsItem>

class Utils {
public:
    inline static bool smallScreen()
        {
        static SmallScreenState state(SmallScreenNA);
        if(state == SmallScreenNA)
            {
            QSize screen = QApplication::desktop()->screenGeometry().size();
            if(std::max(screen.width(), screen.height()) < 600)
                {
                state = SmallScreen;
                }
            else
                {
                state = BigScreen;
                }
            }
        return state;
        }
    
    // At least QGraphicsProxyWidgets need this hack to be focused
    inline static void ForceFocus(QGraphicsItem * item)
        {
        item->setFocus();
        item->hide();
        item->show();
        item->setFocus();
        }
    
private:
    enum SmallScreenState {
        SmallScreenNA  = -1,
        SmallScreen = true,
        BigScreen = false
    };
};

#endif /* UTILS_H_ */
