#ifndef WPPageGraphicsListItem_H
#define WPPageGraphicsListItem_H

#include "wpgraphicslistitem.h"
#include "WPData.h"

class QPixmap;
class BusyIndicator;

class WPPageGraphicsListItem : public WPGraphicsListItem
{
    Q_OBJECT

public:
    WPPageGraphicsListItem(WPPage aPage, BusyIndicator& aBusyIndicator, ThemeData& aThemeData);
    ~WPPageGraphicsListItem();
    
public: // New functions
    void Update(const WPDataComment& aComment);
    WPPage GetPage();
    
    bool operator<(WPPageGraphicsListItem const & other);
    
public: // WPGraphicsListItem implementation
    void paintContent(QPainter* painter, const QStyleOptionGraphicsItem* option, QWidget* widget = 0);
    bool IsBusy();
    bool HasError();
    void handleGeomeryChange();

private:
    void calculateElidedTexts();

private: // Data
    WPPage iPage;
    
    QString iDate;
    QString iTitle;
};

#endif // WPPageGraphicsListItem_H
