#ifndef WPPostGraphicsListItem_H
#define WPPostGraphicsListItem_H

#include "wpgraphicslistitem.h"
#include "WPData.h"

class WPPostGraphicsListItem : public WPGraphicsListItem
{
    Q_OBJECT

public:
    WPPostGraphicsListItem(WPPost aPost, BusyIndicator& aBusyIndicator, ThemeData& aThemeData);
    ~WPPostGraphicsListItem();
    
    bool operator<(WPPostGraphicsListItem const & other);
    
public: // WPGraphicsListItem implementation
    void paintContent(QPainter* painter, const QStyleOptionGraphicsItem* option, QWidget* widget = 0);
    bool IsBusy();
    bool HasError();
    void handleGeomeryChange();

public slots:
    WPPost GetPost() const;
    void calculateElidedTexts();

private: // Data
    WPPost iPost;
    QString iDate;
    QString iTitle;
    QString iCommentsText;
};

#endif // WPPostGraphicsListItem_H
